import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class pesawat here.
 * 
 * @author GameCode 
 * @versi 1. 2015
 */
public class pesawat extends Actor
{
    public int lifePoints = 80;
    public int width = 46;
    public int j = 0;
    public int d = 300;
    public int a = 0;
    
    /**
     * Act - do whatever the pesawat wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        newEnemy();
        j++;
        checkKeys();
        //followMouse();
        keyboardControls();
        explode();
    }   
    
    public void keyboardControls() 
    {
        if(Greenfoot.isKeyDown("right"))
        {
            move(1);
            turn(-1);
        }
        if(Greenfoot.isKeyDown("left"))
        {
            move(1);
            turn(1);
        }
        if(Greenfoot.isKeyDown("up"))
        {
            //move(1);
            //turn(1);
            //this.setImage("airplaneatas.png");
            this.setLocation(this.getX(), this.getY()-5);
        }
        if(Greenfoot.isKeyDown("down"))
        {
            //move(1);
            //turn(-1);
            //this.setImage("airplanebawah.png");
            this.setLocation(this.getX(), this.getY()+5);
        }  
       
    }
    
    /**
     * The pesawat shoots with both wings:
     * It adds two Laser.class to the World.
     */
    public void shoot(int a)
    {
        double angle = Math.toRadians( getRotation() +90* a);
        int x = (int) Math.round(getX() + Math.cos(angle) * width);
        int y = (int) Math.round(getY() + Math.sin(angle) * width);
        getWorld().addObject(new Laser(getRotation()), x, y);
        Greenfoot.playSound("LASER BEAM 2.WAV");
    }
    
    /**
     * The pesawat checks the Keys from the Keyboard.
     * Depending on the keys it turns right/left or shoots.
     */
    public void checkKeys()
    {
        if(Greenfoot.isKeyDown("right"))
           setRotation(getRotation()+2);
        if(Greenfoot.isKeyDown("left"))
          setRotation(getRotation()-2);
        if(Greenfoot.isKeyDown("up"))
           getY();
        if(Greenfoot.isKeyDown("down"))
           getX();
        
        if(Greenfoot.isKeyDown("space") && j>20|| Greenfoot.mouseClicked(null)) {
            shoot(1); 
            shoot(-1);
            j=0;
        }
    }
    
    /**
     * The pesawat always turns to the mouse.
     */
    public void followMouse()
    {
        MouseInfo m = Greenfoot.getMouseInfo();
        if(m != null) 
        {  
             int x = m.getX() - getX();  
             int y = m.getY() - getY();  
             double r = Math.toDegrees(Math.atan2(x, y)) - 90;  
             setRotation(-(int) r);  
        }  
    }
    
    /**
     * The pesawat explodes if it hasn't any lifepoints.
     */
    public void explode()
    {
        if(Laser()&&lifePoints>0)
            lifePoints --;
        if(lifePoints == 0) {
            getWorld().addObject(new ledakan(), getX(), getY()); 
            setImage("gamesover.png");
            setRotation(0);
            Greenfoot.stop();
            //getWorld().removeObject(this);
        }
    }
    
     /**
     * The pesawat adds an Enemy to the World.
     */
    public void newEnemy()
    {
        a++;
        if(a%d == 0) {
            int z = Greenfoot.getRandomNumber(5);
            int x = Greenfoot.getRandomNumber(getWorld().getWidth());
            int y = Greenfoot.getRandomNumber(getWorld().getHeight());
            
            if(z == 0)
                addEnemy(800, y);
            if(z == 1)
                addEnemy(x, 700);
            if(z == 2)
                addEnemy(-100, y);
            if(z == 3 || z == 4)
                addEnemy(x, -100);
            
            if(d > 130)
                d = d - 3;
        }
    }
    
    /**
     * Adds one Enemy to the world which points to the pesawat.
     */
    public void addEnemy(int x, int y)
    {
        int nX = x - getX();  
        int nY = y - getY();  
        double r = Math.toDegrees(Math.atan2(nX, nY)) - 90;   
        getWorld().addObject(new roket((int)r), x, y);
    }
    
    /**
     * Checks if a Laser is on the pesawat's field.
     */
    public boolean Laser()
    {
        if(getOneIntersectingObject(RedLaser.class)!=null)
            return true;
        return false;
    }
}
