import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class EnemyShip here.
 * 
 * @author GameCode 
 * @version 2011 Juli 14.
 */
public class roket extends Actor
{
    public int j = 0;
    public int a = 0;
    public int width = 6;
    public int v = 3;
    public int lifePoints = 2;
    
    public roket(int r)
    {
        setRotation(r);
    }
    
    /**
     * Act - do whatever the EnemyShip wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(lifePoints != 0) {
            j++;
            attack();
            flyRandom();
            try {
                explode();
            }
            catch(Exception e){
            }
        }
    }
    
    /**
     * The Enemy rotates into a random Location.
     * Then it moves.
     */
    public void flyRandom()
    {
        a++;
        if(a%90 == 0)
            setRotation(getRotation() + Greenfoot.getRandomNumber(450 - 270)+270);
        setRotation(getRotation() + Greenfoot.getRandomNumber(6)-3); 
        move(v);
        remove();
    }
    
    /**
     * The Enemy shoots.
     */
    public void attack()
    {
        if(j>20)
        {
            shoot(1);
            shoot(-1);
            j = 0;
        }
    }
    /**
     * The enemy shoots:
     * It adds two Laser.class to the World.
     */
    public void shoot(int a)
    {
        double angle = Math.toRadians( getRotation() +90* a);
        int x = (int) Math.round(getX() + Math.cos(angle) * width);
        int y = (int) Math.round(getY() + Math.sin(angle) * width);
        
        getWorld().addObject(new RedLaser(getRotation()), x, y);
    }
    
    /**
     * The enemy explodes if it hasn't any lifepoints.
     */
    public void explode()
    {
        if(Laser()&&lifePoints>0)
            lifePoints --;
        if(lifePoints == 0) {
            getWorld().addObject(new ledakan(), getX(), getY()); 
            sky.shots++;
            getWorld().removeObject(this);
        }
        
    }
    
    /**
     * The enemy removes itself if its out of the world.
     */
    public void remove()
    {
        if(getX()<-200 || getX() > getWorld().getWidth()+200)
            getWorld().removeObject(this);
        else if(getY()<-200 || getY() > getWorld().getHeight()+200)
            getWorld().removeObject(this);  
    }
    
    /**
     * Checks if a Laser is on the enemy's field.
     */
    public boolean Laser()
    {
        if(getOneIntersectingObject(Laser.class)!=null)
            return true;
        return false;
    }
}
