import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Laser here.
 * 
 * @author GameCode 
 * @version 2011 Juli 14.
 */
public class RedLaser extends Actor
{
    public int v = 6;
    public String image;
    
    /**
     * Constructor:
     * The Laser rotates to the given Rotation
     * The Laser sets his colour to the given one
     */
    public RedLaser(int r)
    {
        setRotation(r);      
    }
    
    /**
     * The Laser moves into the direction it is facing.
     */
    public void act() 
    {
        move(v);
        remove();
    }   
    
    /**
     * The Laser removes itself if its out of the world.
     */
    public void remove()
    {
        if(getX()<-5 || getX() > getWorld().getWidth()+5)
            getWorld().removeObject(this);
        else if(getY()<-5 || getY() > getWorld().getHeight()+5)
            getWorld().removeObject(this);
    }
}
